Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/udp4_subr.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/udp4_subr.c	(revision 331)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/udp4_subr.c	(revision 331)
@@ -0,0 +1,203 @@
+/*
+ *  TINET (UDP/IP Protocol Stack)
+ * 
+ *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
+ *                   Tomakomai National College of Technology, JAPAN
+ *
+ *  ä¸è¨èä½æ¨©è
+ã¯ï¼ä»¥ä¸ã® (1)ï½(4) ã®æ¡ä»¶ãï¼Free Software Foundation 
+ *  ã«ãã£ã¦å
+¬è¡¨ããã¦ãã GNU General Public License ã® Version 2 ã«è¨
+ *  è¿°ããã¦ããæ¡ä»¶ãæºããå ´åã«éãï¼æ¬ã½ããã¦ã§ã¢ï¼æ¬ã½ããã¦ã§ã¢
+ *  ãæ¹å¤ãããã®ãå«ãï¼ä»¥ä¸åãï¼ãä½¿ç¨ã»è¤è£½ã»æ¹å¤ã»åé
+å¸ï¼ä»¥ä¸ï¼
+ *  å©ç¨ã¨å¼ã¶ï¼ãããã¨ãç¡åã§è¨±è«¾ããï¼
+ *  (1) æ¬ã½ããã¦ã§ã¢ãã½ã¼ã¹ã³ã¼ãã®å½¢ã§å©ç¨ããå ´åã«ã¯ï¼ä¸è¨ã®èä½
+ *      æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨ã®ç¡ä¿è¨¼è¦å®ãï¼ãã®ã¾ã¾ã®å½¢ã§ã½ã¼
+ *      ã¹ã³ã¼ãä¸­ã«å«ã¾ãã¦ãããã¨ï¼
+ *  (2) æ¬ã½ããã¦ã§ã¢ãï¼ã©ã¤ãã©ãªå½¢å¼ãªã©ï¼ä»ã®ã½ããã¦ã§ã¢éçºã«ä½¿
+ *      ç¨ã§ããå½¢ã§åé
+å¸ããå ´åã«ã¯ï¼åé
+å¸ã«ä¼´ããã­ã¥ã¡ã³ãï¼å©ç¨
+ *      è
+ããã¥ã¢ã«ãªã©ï¼ã«ï¼ä¸è¨ã®èä½æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨
+ *      ã®ç¡ä¿è¨¼è¦å®ãæ²è¼ãããã¨ï¼
+ *  (3) æ¬ã½ããã¦ã§ã¢ãï¼æ©å¨ã«çµã¿è¾¼ããªã©ï¼ä»ã®ã½ããã¦ã§ã¢éçºã«ä½¿
+ *      ç¨ã§ããªãå½¢ã§åé
+å¸ããå ´åã«ã¯ï¼æ¬¡ã®æ¡ä»¶ãæºãããã¨ï¼
+ *    (a) åé
+å¸ã«ä¼´ããã­ã¥ã¡ã³ãï¼å©ç¨è
+ããã¥ã¢ã«ãªã©ï¼ã«ï¼ä¸è¨ã®è
+ *        ä½æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨ã®ç¡ä¿è¨¼è¦å®ãæ²è¼ãããã¨ï¼
+ *  (4) æ¬ã½ããã¦ã§ã¢ã®å©ç¨ã«ããç´æ¥çã¾ãã¯éæ¥çã«çãããããªãæ
+ *      å®³ãããï¼ä¸è¨èä½æ¨©è
+ããã³TOPPERSãã­ã¸ã§ã¯ããå
+è²¬ãããã¨ï¼
+ *
+ *  æ¬ã½ããã¦ã§ã¢ã¯ï¼ç¡ä¿è¨¼ã§æä¾ããã¦ãããã®ã§ããï¼ä¸è¨èä½æ¨©è
+ã
+ *  ãã³TOPPERSãã­ã¸ã§ã¯ãã¯ï¼æ¬ã½ããã¦ã§ã¢ã«é¢ãã¦ï¼ãã®é©ç¨å¯è½æ§ã
+ *  å«ãã¦ï¼ãããªãä¿è¨¼ãè¡ããªãï¼ã¾ãï¼æ¬ã½ããã¦ã§ã¢ã®å©ç¨ã«ããç´
+ *  æ¥çã¾ãã¯éæ¥çã«çãããããªãæå®³ã«é¢ãã¦ãï¼ãã®è²¬ä»»ãè² ããªãï¼
+ * 
+ *  @(#) $Id$
+ */
+
+/*
+ * Copyright (c) 1982, 1986, 1988, 1990, 1993, 1995
+ *	The Regents of the University of California.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must ceproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *	This product includes software developed by the University of
+ *	California, Berkeley and its contributors.
+ * 4. Neither the name of the University nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#ifdef SUPPORT_IGMP
+#define UDP4_IS_ADDR_MULTICAST igmp_is_joined_group
+#else
+#define UDP4_IS_ADDR_MULTICAST IN4_IS_ADDR_MULTICAST
+#endif
+
+#ifdef DHCP_CFG
+#ifdef ETHER_CFG_MULTICAST
+/*
+ *  udp4_is_dstaddr_accept -- UDP ã®ãã¦å
+ã¢ãã¬ã¹ãæ­£ããããã§ãã¯ããã
+ *
+ *    DHCP_CFG ãå®ç¾©ããã¦ããã¨ãã¯ãä»¥ä¸ã®ãã¼ã¿ã°ã©ã ãåä¿¡ããã
+ *
+ *      ã»ãã¦å
+ã¢ãã¬ã¹ããã­ã¼ãã­ã£ã¹ã
+ *      ã»ã­ã¼ã«ã«ã¢ãã¬ã¹ãæªå®ç¾©
+ */
+
+static bool_t
+udp4_is_dstaddr_accept (T_IN4_ADDR *myaddr, T_NET_BUF *input)
+{
+	T_IP4_HDR	*ip4h;
+	T_IN4_ADDR	dst;
+	T_IFNET	*ifp = IF_GET_IFNET();
+
+	ip4h = GET_IP4_HDR(input);
+	dst = ntohl(ip4h->dst);
+
+	if (ifp->in4_ifaddr.addr == IPV4_ADDRANY    ||
+		dst == IPV4_ADDR_BROADCAST ||
+		dst == ((ifp->in4_ifaddr.addr & ifp->in4_ifaddr.mask) | ~ifp->in4_ifaddr.mask) ||
+		UDP4_IS_ADDR_MULTICAST(dst))
+		return true;
+	else
+		return inn4_is_dstaddr_accept(myaddr, input);
+	}
+#else
+/*
+ *  udp4_is_dstaddr_accept -- UDP ã®ãã¦å
+ã¢ãã¬ã¹ãæ­£ããããã§ãã¯ããã
+ *
+ *    DHCP_CFG ãå®ç¾©ããã¦ããã¨ãã¯ãä»¥ä¸ã®ãã¼ã¿ã°ã©ã ãåä¿¡ããã
+ *
+ *      ã»ãã¦å
+ã¢ãã¬ã¹ããã­ã¼ãã­ã£ã¹ã
+ *      ã»ã­ã¼ã«ã«ã¢ãã¬ã¹ãæªå®ç¾©
+ */
+
+static bool_t
+udp4_is_dstaddr_accept (T_IN4_ADDR *myaddr, T_NET_BUF *input)
+{
+	T_IP4_HDR	*ip4h;
+	T_IFNET	*ifp = IF_GET_IFNET();
+
+	ip4h = GET_IP4_HDR(input);
+
+	if (ifp->in4_ifaddr.addr == IPV4_ADDRANY    ||
+	    ntohl(ip4h->dst) == IPV4_ADDR_BROADCAST ||
+	    ntohl(ip4h->dst) == ((ifp->in4_ifaddr.addr & ifp->in4_ifaddr.mask) | ~ifp->in4_ifaddr.mask))
+		return true;
+	else
+		return inn4_is_dstaddr_accept(myaddr, input);
+	}
+#endif	/* of #ifdef ETHER_CFG_MULTICAST */
+#else
+#ifdef ETHER_CFG_MULTICAST
+
+/*
+ *  udp_dstaddr_accept -- UDP ã®ãã¦å
+ã¢ãã¬ã¹ãæ­£ããããã§ãã¯ããã
+ *
+ *    ä»¥ä¸ã®å ´åããã¼ã¿ã°ã©ã ãåä¿¡ããã
+ *
+ *      ã»ãã¦å
+ã¢ãã¬ã¹ããã­ã¼ãã­ã£ã¹ã
+ */
+
+static bool_t
+udp4_is_dstaddr_accept (T_IN4_ADDR *myaddr, T_NET_BUF *input)
+{
+	T_IP4_HDR	*ip4h;
+	T_IN4_ADDR	dst;
+	T_IFNET	*ifp = IF_GET_IFNET();
+
+	ip4h = GET_IP4_HDR(input);
+	dst = ntohl(ip4h->dst);
+
+	if (dst == IPV4_ADDR_BROADCAST ||
+	    dst == ((ifp->in4_ifaddr.addr & ifp->in4_ifaddr.mask) | ~ifp->in4_ifaddr.mask) ||
+		UDP4_IS_ADDR_MULTICAST(dst))
+		return true;
+	else
+		return inn4_is_dstaddr_accept(myaddr, input);
+	}
+
+#else	/* of #ifdef ETHER_CFG_MULTICAST */
+
+/*
+ *  udp4_is_dstaddr_accept -- UDP ã®ãã¦å
+ã¢ãã¬ã¹ãæ­£ããããã§ãã¯ããã
+ *
+ *    ä»¥ä¸ã®å ´åããã¼ã¿ã°ã©ã ãåä¿¡ããã
+ *
+ *      ã»ãã¦å
+ã¢ãã¬ã¹ããã­ã¼ãã­ã£ã¹ã
+ */
+
+static bool_t
+udp4_is_dstaddr_accept (T_IN4_ADDR *myaddr, T_NET_BUF *input)
+{
+	T_IP4_HDR	*ip4h;
+	T_IFNET		*ifp = IF_GET_IFNET();
+
+	ip4h = GET_IP4_HDR(input);
+
+	if (ntohl(ip4h->dst) == IPV4_ADDR_BROADCAST ||
+	    ntohl(ip4h->dst) == ((ifp->in4_ifaddr.addr & ifp->in4_ifaddr.mask) | ~ifp->in4_ifaddr.mask))
+		return true;
+	else
+		return inn4_is_dstaddr_accept(myaddr, input);
+	}
+
+#endif	/* of #ifdef ETHER_CFG_MULTICAST */
+#endif	/* of #ifdef DHCP_CFG */
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/udp_input.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/udp_input.c	(revision 321)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/udp_input.c	(revision 331)
@@ -2,5 +2,5 @@
  *  TINET (TCP/IP Protocol Stack)
  * 
- *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
+ *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
  *                   Tomakomai National College of Technology, JAPAN
  *
@@ -72,4 +72,5 @@
 #include <sil.h>
 #include <t_syslog.h>
+#include "tinet_cfg.h"
 
 #endif	/* of #ifdef TARGET_KERNEL_ASP */
@@ -79,5 +80,5 @@
 #include <s_services.h>
 #include <t_services.h>
-#include "kernel_id.h"
+#include "tinet_id.h"
 
 #endif	/* of #ifdef TARGET_KERNEL_JSP */
@@ -92,4 +93,5 @@
 #include <net/ppp_ipcp.h>
 #include <net/net.h>
+#include <net/net_endian.h>
 #include <net/net_buf.h>
 #include <net/net_count.h>
@@ -97,14 +99,8 @@
 #include <netinet/in.h>
 #include <netinet/in_var.h>
-#include <netinet6/in6.h>
-#include <netinet6/in6_var.h>
 #include <netinet/in_itron.h>
 #include <netinet/ip.h>
 #include <netinet/ip_var.h>
-#include <netinet/ip6.h>
-#include <netinet6/ip6_var.h>
 #include <netinet/ip_icmp.h>
-#include <netinet/icmp6.h>
-
 #include <netinet/udp.h>
 #include <netinet/udp_var.h>
@@ -124,256 +120,56 @@
 #endif	/* of #ifdef SUPPORT_MIB */
 
-#if defined(SUPPORT_INET4)
-
-#ifdef DHCP_CFG
-
 /*
- *  udp_dstaddr_accept -- UDP のあて先アドレスが正しいかチェックする。
- *
- *    DHCP_CFG が定義されているときは、以下のデータグラムを受信する。
- *
- *      ・あて先アドレスがブロードキャスト
- *      ・ローカルアドレスが未定義
+ *  IPv6 と IPv4 で引数が異なる関数のコンパイル
  */
 
-static bool_t
-udp_is_dstaddr_accept (T_IN4_ADDR *myaddr, T_IN4_ADDR *dstaddr)
-{
-	T_IFNET	*ifp = IF_GET_IFNET();
+#undef	IN_COPY_TO_HOST
 
-	if (ifp->in_ifaddr.addr == IPV4_ADDRANY ||
-	    ntohl(*dstaddr) == IPV4_ADDR_BROADCAST ||
-	    ntohl(*dstaddr) == ((ifp->in_ifaddr.addr & ifp->in_ifaddr.mask) | ~ifp->in_ifaddr.mask))
-		return true;
-	else
-		return IN_IS_DSTADDR_ACCEPT(myaddr, dstaddr);
-	}
+#if defined(_IP6_CFG) && TNUM_UDP6_CEPID > 0
 
-#elif defined(ETHER_CFG_MULTICAST)
+#define UDP_INPUT		udp6_input
+#define UDP_INPUT_SELECT	udp6_input_select
+#define UDP_REPLY_NO_PORT	udp6_reply_no_port
+#define UDP_FIND_CEP		udp6_find_cep
+#define GET_UDP_CEPID		GET_UDP6_CEPID
+#define T_UDP_CEP		T_UDP6_CEP
+#define API_PROTO		API_PROTO_IPV6
 
-/*
- *  udp_dstaddr_accept -- UDP のあて先アドレスが正しいかチェックする。
- *
- *    以下の場合もデータグラムを受信する。
- *
- *      ・あて先アドレスがブロードキャスト
- */
+#if defined(_IP4_CFG)
+#define IN_COPY_TO_HOST		inn_copy_to_host
+#else
+#define IN_COPY_TO_HOST		IN6_COPY_TO_HOST
+#endif
 
-static bool_t
-udp_is_dstaddr_accept (T_IN4_ADDR *myaddr, T_IN4_ADDR *dstaddr)
-{
-	T_IFNET	*ifp = IF_GET_IFNET();
-	T_IN4_ADDR	dst = ntohl(*dstaddr);
+#include <netinet6/udp6_input.c>
+#include <netinet/udpn_input.c>
 
-	if (dst == IPV4_ADDR_BROADCAST ||
-	    dst == ((ifp->in_ifaddr.addr & ifp->in_ifaddr.mask) | ~ifp->in_ifaddr.mask) ||
-		IN4_IS_ADDR_MULTICAST(dst))
-		return true;
-	else
-		return IN_IS_DSTADDR_ACCEPT(myaddr, dstaddr);
-	}
+#undef	UDP_INPUT
+#undef	UDP_INPUT_SELECT
+#undef	UDP_REPLY_NO_PORT
+#undef	UDP_FIND_CEP
+#undef	GET_UDP_CEPID
+#undef	T_UDP_CEP
+#undef	IN_COPY_TO_HOST
+#undef  API_PROTO
 
-#else	/* of #ifdef DHCP_CFG */
+#endif	/* of #if defined(_IP6_CFG) && TNUM_UDP6_CEPID > 0 */
 
-/*
- *  udp_dstaddr_accept -- UDP のあて先アドレスが正しいかチェックする。
- *
- *    以下の場合もデータグラムを受信する。
- *
- *      ・あて先アドレスがブロードキャスト
- */
+#if defined(_IP4_CFG) && ( (TNUM_UDP4_CEPID > 0) || \
+                          ((TNUM_UDP6_CEPID > 0) && defined(API_CFG_IP4MAPPED_ADDR)))
 
-static bool_t
-udp_is_dstaddr_accept (T_IN4_ADDR *myaddr, T_IN4_ADDR *dstaddr)
-{
-	T_IFNET	*ifp = IF_GET_IFNET();
+#define UDP_INPUT		udp4_input
+#define UDP_INPUT_SELECT	udp4_input_select
+#define UDP_REPLY_NO_PORT	udp4_reply_no_port
+#define UDP_FIND_CEP		udp4_find_cep
+#define GET_UDP_CEPID		GET_UDP4_CEPID
+#define T_UDP_CEP		T_UDP4_CEP
+#define IN_COPY_TO_HOST		IN4_COPY_TO_HOST
+#define API_PROTO		API_PROTO_IPV4
 
-	if (ntohl(*dstaddr) == IPV4_ADDR_BROADCAST ||
-	    ntohl(*dstaddr) == ((ifp->in_ifaddr.addr & ifp->in_ifaddr.mask) | ~ifp->in_ifaddr.mask))
-		return true;
-	else
-		return IN_IS_DSTADDR_ACCEPT(myaddr, dstaddr);
-	}
+#include <netinet/udp4_input.c>
+#include <netinet/udpn_input.c>
 
-#endif	/* of #ifdef DHCP_CFG */
-
-#endif	/* of #if defined(SUPPORT_INET4) */
-
-#if defined(SUPPORT_INET6)
-
-/*
- *  udp_dstaddr_accept -- UDP のあて先アドレスが正しいかチェックする。
- *
- *    以下の場合もデータグラムを受信する。
- *
- *      ・あて先アドレスがマルチキャスト
- */
-
-static bool_t
-udp_is_dstaddr_accept (T_IN6_ADDR *myaddr, T_IN6_ADDR *dstaddr)
-{
-	if (IN6_IS_ADDR_MULTICAST(dstaddr))
-		return true;
-	else
-		return IN_IS_DSTADDR_ACCEPT(myaddr, dstaddr);
-	}
-
-#endif	/* of #if defined(SUPPORT_INET6) */
-
-/*
- *  udp_input -- UDP の入力関数
- */
-
-uint_t
-udp_input (T_NET_BUF **inputp, uint_t *offp, uint_t *nextp)
-{
-	T_NET_BUF	*input = *inputp;
-	T_UDP_CEP	*cep;
-	T_UDP_HDR	*udph;
-	T_IP_HDR	*iph;
-	int_t		ix;
-	uint_t		len, hlen, ulen;
-
-	hlen = (uint_t)GET_IF_IP_HDR_SIZE(input);
-
-	NET_COUNT_UDP(net_count_udp.in_octets,  input->len - hlen);
-	NET_COUNT_UDP(net_count_udp.in_packets, 1);
-	NET_COUNT_MIB(udp_stats.udpInDatagrams, 1);
-
-	/* ヘッダ長をチェックする。*/
-	if (input->len < hlen + UDP_HDR_SIZE)
-		goto buf_rel;
-
-	udph = (T_UDP_HDR *)(input->buf + *offp);
-
-	/* データグラム長をチェックする */
-	ulen  = ntohs(udph->ulen);
-	if (ulen != input->len - hlen)
-		goto buf_rel;
-
-	/* 宛先ポートが 0 のデータグラムは破棄する。RFC768 */
-	if (udph->dport == 0)
-		goto buf_rel;
-
-#ifdef UDP_CFG_IN_CHECKSUM
-
-	/* チェックサムをチェックする */
-	if (udph->sum && IN_CKSUM(input, IPPROTO_UDP, *offp, ulen) != 0)
-		goto buf_rel;
-
-#endif	/* of #ifdef UDP_CFG_IN_CHECKSUM */
-
-	iph = GET_IP_HDR(input);
-
-	/* 宛先アドレスとポートをチェックする */
-	for (ix = tmax_udp_ccepid; ix -- > 0; ) {
-		cep = &udp_cep[ix];
-		if (VALID_UDP_CEP(cep) &&
-		    udp_is_dstaddr_accept(&cep->myaddr.ipaddr, &iph->dst) &&
-		    ntohs(udph->dport) == cep->myaddr.portno) {
-			len = (uint_t)(ntohs(udph->ulen) - UDP_HDR_SIZE);
-
-			if (cep->rcv_tskid != TA_NULL) {	/* 非ノンブロッキングコールでペンディング中 */
-				if (psnd_dtq(cep->rcvqid, (intptr_t)input) != E_OK)
-					goto buf_rel;
-				}
-
-#ifdef UDP_CFG_NON_BLOCKING
-
-			else if (cep->rcv_p_dstaddr != NULL) {	/* ノンブロッキングコールでペンディング中 */
-
-				/* p_dstaddr を設定する。*/
-				cep->rcv_p_dstaddr->portno = ntohs(udph->sport);
-				IN_COPY_TO_HOST(&cep->rcv_p_dstaddr->ipaddr, &GET_IP_HDR(input)->src);
-
-				/* データをバッファに移す。*/
-				memcpy(cep->rcv_data, GET_UDP_SDU(input, *offp),
-				       (size_t)(len < cep->rcv_len ? len : cep->rcv_len));
-				syscall(rel_net_buf(input));
-
-				if (IS_PTR_DEFINED(cep->callback))
-
-#ifdef TCP_CFG_NON_BLOCKING_COMPAT14
-
-					(*cep->callback)(GET_UDP_CEPID(cep), TFN_UDP_RCV_DAT, (void*)(uint32_t)len);
-
-#else	/* of #ifdef TCP_CFG_NON_BLOCKING_COMPAT14 */
-
-					(*cep->callback)(GET_UDP_CEPID(cep), TFN_UDP_RCV_DAT, (void*)&len);
-
-#endif	/* of #ifdef TCP_CFG_NON_BLOCKING_COMPAT14 */
-
-				else
-					syslog(LOG_WARNING, "[UDP] no call back, CEP: %d.", GET_UDP_CEPID(cep));
-				cep->rcv_p_dstaddr = NULL;
-				}
-
-#endif	/* of #ifdef UDP_CFG_NON_BLOCKING */
-
-			else if (IS_PTR_DEFINED(cep->callback)) {
-
-				/* コールバック関数を呼び出す。*/
-				cep->cb_netbuf = input;
-
-#ifdef TCP_CFG_NON_BLOCKING_COMPAT14
-
-				(*cep->callback)(GET_UDP_CEPID(cep), TEV_UDP_RCV_DAT, (void*)(uint32_t)len);
-
-#else	/* of #ifdef TCP_CFG_NON_BLOCKING_COMPAT14 */
-
-				(*cep->callback)(GET_UDP_CEPID(cep), TEV_UDP_RCV_DAT, (void*)&len);
-
-#endif	/* of #ifdef TCP_CFG_NON_BLOCKING_COMPAT14 */
-
-				/*
-				 *  ネットワークバッファがそのままであれば、コールバック関数内で
-				 *  データを読み出さなかったことになるので、捨てる。
-				 */
-				if (cep->cb_netbuf != NULL)
-					syscall(rel_net_buf(cep->cb_netbuf));
-				}
-			else
-				goto buf_rel;
-
-			return IPPROTO_DONE;
-			}
-		}
-
-	NET_COUNT_MIB(udp_stats.udpNoPorts, 1);
-
-#if defined(SUPPORT_INET4)
-
-	/* ローカル IP アドレスに届いたデータグラムのみ ICMP エラーを通知する。*/
-	if (ntohl(iph->dst) == IF_GET_IFNET()->in_ifaddr.addr) {
-		syslog(LOG_INFO, "[UDP] unexp port: %d.", ntohs(udph->dport));
-
-		icmp_error(ICMP4_UNREACH_PORT, input);
-		/* icmp_error では、ネットワークバッファ input を返却しないので下へ抜ける。*/
-		}
-
-#endif	/* of #if defined(SUPPORT_INET4) */
-
-#if defined(SUPPORT_INET6)
-
-	/* マルチキャストアドレスに届いたデータグラムは ICMP エラーを通知しない。*/
-	if (!IN6_IS_ADDR_MULTICAST(&iph->dst)) {
-		syslog(LOG_INFO, "[UDP] unexp port: %d.", ntohs(udph->dport));
-
-		/* icmp6_error で、ネットワークバッファ input を返却する。*/
-		icmp6_error(input, ICMP6_DST_UNREACH, ICMP6_DST_UNREACH_NOPORT, 0);
-
-		NET_COUNT_UDP(net_count_udp.in_err_packets, 1);
-		NET_COUNT_MIB(udp_stats.udpInErrors, 1);
-		return IPPROTO_DONE;
-		}
-
-#endif	/* of #if defined(SUPPORT_INET6) */
-
-buf_rel:
-	NET_COUNT_UDP(net_count_udp.in_err_packets, 1);
-	NET_COUNT_MIB(udp_stats.udpInErrors, 1);
-	syscall(rel_net_buf(input));
-	return IPPROTO_DONE;
-	}
+#endif	/* of #if defined(_IP4_CFG) && TNUM_UDP4_CEPID > 0 */
 
 #endif	/* of #ifdef SUPPORT_UDP */
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/udp_output.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/udp_output.c	(revision 321)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/udp_output.c	(revision 331)
@@ -2,5 +2,5 @@
  *  TINET (TCP/IP Protocol Stack)
  * 
- *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
+ *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
  *                   Tomakomai National College of Technology, JAPAN
  *
@@ -73,4 +73,5 @@
 #include <t_syslog.h>
 #include "kernel_cfg.h"
+#include "tinet_cfg.h"
 
 #endif	/* of #ifdef TARGET_KERNEL_ASP */
@@ -81,4 +82,5 @@
 #include <t_services.h>
 #include "kernel_id.h"
+#include "tinet_id.h"
 
 #endif	/* of #ifdef TARGET_KERNEL_JSP */
@@ -92,9 +94,9 @@
 #include <net/ethernet.h>
 #include <net/net.h>
+#include <net/net_endian.h>
 #include <net/net_buf.h>
 #include <net/net_count.h>
 
 #include <netinet/in.h>
-#include <netinet6/in6.h>
 #include <netinet/in_var.h>
 #include <netinet/in_itron.h>
@@ -102,9 +104,4 @@
 #include <netinet/ip_var.h>
 #include <netinet/ip_icmp.h>
-#include <netinet6/in6_var.h>
-#include <netinet/ip6.h>
-#include <netinet6/ip6_var.h>
-#include <netinet6/nd6.h>
-#include <netinet/icmp6.h>
 #include <netinet/udp.h>
 #include <netinet/udp_var.h>
@@ -115,109 +112,44 @@
 
 /*
- *  関数
- */
-
-static void udp_output (T_UDP_CEP *cep);
-
-/*
- *  UDP 出力タスク
- *  ノンブロッキングコールを組み込んだとき使用する。
- */
-
-static void
-udp_output (T_UDP_CEP *cep)
-{
-	T_NET_BUF	*output;
-	T_UDP_HDR	*udph;
-	ER_UINT		error;
-
-#ifdef UDP_CFG_OUT_CHECKSUM
-	uint16_t	sum;
-#endif	/* of #ifdef UDP_CFG_OUT_CHECKSUM */
-
-	/* IP データグラムを割り当てる。*/
-	if ((error = IN_GET_DATAGRAM(&output, (uint_t)(UDP_HDR_SIZE + cep->snd_len), 0,
-	                             &cep->snd_p_dstaddr->ipaddr,
-	                             &cep->myaddr.ipaddr,
-	                             IPPROTO_UDP, IP_DEFTTL, 
-	                             NBA_SEARCH_ASCENT, TMO_UDP_OUTPUT)) != E_OK) {
-		goto err_ret;
-		}
-
-	/* UDP ヘッダに情報を設定する。*/
-	udph		= GET_UDP_HDR(output, IF_IP_UDP_HDR_OFFSET);
-	udph->sport	= htons(cep->myaddr.portno);
-	udph->dport	= htons(cep->snd_p_dstaddr->portno);
-	udph->ulen	= htons(UDP_HDR_SIZE + cep->snd_len);
-	udph->sum	= 0;
-
-	/* データをコピーする。*/
-	memcpy((void*)GET_UDP_SDU(output, IF_IP_UDP_HDR_OFFSET),
-	       cep->snd_data, (size_t)cep->snd_len);
-
-#ifdef UDP_CFG_OUT_CHECKSUM
-
-	sum = IN_CKSUM(output, IPPROTO_UDP, IF_IP_UDP_HDR_OFFSET,
-	               (uint_t)(UDP_HDR_SIZE + cep->snd_len));
-
-	/* 計算したチェックサムの値が 0 なら 0xffff を入れる。*/
-	if (sum == 0)
-		sum = UINT_C(0xffff);
-	udph->sum = sum;
-
-#endif/* of #ifdef UDP_CFG_OUT_CHECKSUM */
-
-	/* ネットワークバッファ長を調整する。*/
-	output->len = (uint16_t)(IF_IP_UDP_HDR_SIZE + cep->snd_len);
-
-	/* ネットワーク層 (IP) の出力関数を呼び出す。*/
-	if ((error = IP_OUTPUT(output, TMO_UDP_OUTPUT)) != E_OK)
-		goto err_ret;
-
-
-	NET_COUNT_MIB(udp_stats.udpOutDatagrams, 1);
-
-	if (IS_PTR_DEFINED(cep->callback)) {
-
-		if (error == E_OK)
-			error = cep->snd_len;
-
-#ifdef TCP_CFG_NON_BLOCKING_COMPAT14
-
-		(*cep->callback)(GET_UDP_CEPID(cep), TFN_UDP_SND_DAT, (void*)error);
-
-#else	/* of #ifdef TCP_CFG_NON_BLOCKING_COMPAT14 */
-
-		(*cep->callback)(GET_UDP_CEPID(cep), TFN_UDP_SND_DAT, (void*)&error);
-
-#endif	/* of #ifdef TCP_CFG_NON_BLOCKING_COMPAT14 */
-
-		}
-	else
-		syslog(LOG_WARNING, "[UDP] no call back, CEP: %d.", GET_UDP_CEPID(cep));
-	cep->snd_p_dstaddr = NULL;
-	return;
-
-err_ret:
-	NET_COUNT_UDP(net_count_udp.out_err_packets, 1);
-	if (IS_PTR_DEFINED(cep->callback)) {
-
-#ifdef TCP_CFG_NON_BLOCKING_COMPAT14
-
-		(*cep->callback)(GET_UDP_CEPID(cep), TFN_UDP_SND_DAT, (void*)E_NOMEM);
-
-#else	/* of #ifdef TCP_CFG_NON_BLOCKING_COMPAT14 */
-
-		error = E_NOMEM;
-		(*cep->callback)(GET_UDP_CEPID(cep), TFN_UDP_SND_DAT, (void*)&error);
-
-#endif	/* of #ifdef TCP_CFG_NON_BLOCKING_COMPAT14 */
-
-		}
-	else
-		syslog(LOG_WARNING, "[UDP] no call back, CEP: %d.", GET_UDP_CEPID(cep));
-	cep->snd_p_dstaddr = NULL;
-	return;
-	}
+ *  IPv6 と IPv4 で引数が異なる関数のコンパイル
+ */
+
+#undef	IN_GET_DATAGRAM
+
+#if defined(_IP6_CFG) 
+
+#define UDP_OUTPUT		udp6_output
+#define GET_UDP_CEPID		GET_UDP6_CEPID
+#define T_UDP_CEP		T_UDP6_CEP
+#define API_PROTO		API_PROTO_IPV6
+
+#if defined(_IP4_CFG)
+#define	IN_GET_DATAGRAM		inn_get_datagram
+#else
+#define	IN_GET_DATAGRAM		in6_get_datagram
+#endif
+
+#include <netinet/udpn_output.c>
+
+#undef	UDP_OUTPUT
+#undef	GET_UDP_CEPID
+#undef	T_UDP_CEP
+#undef  API_PROTO
+#undef	IN_GET_DATAGRAM
+
+#endif	/* of #if defined(_IP6_CFG)  */
+
+#if defined(_IP4_CFG) && TNUM_UDP4_CEPID > 0
+
+#define UDP_OUTPUT		udp4_output
+#define GET_UDP_CEPID		GET_UDP4_CEPID
+#define T_UDP_CEP		T_UDP4_CEP
+#define API_PROTO		API_PROTO_IPV4
+
+#define	IN_GET_DATAGRAM		in4_get_datagram
+
+#include <netinet/udpn_output.c>
+
+#endif	/* of #if defined(_IP4_CFG) && TNUM_UDP4_CEPID > 0 */
 
 /*
@@ -236,10 +168,10 @@
 
 
-#if defined(SUPPORT_INET6) && !defined(SUPPORT_TCP)
+#if defined(_IP6_CFG) && !defined(SUPPORT_TCP)
 
 	/* IPv6 のステートレス・アドレス自動設定を実行する。*/
 	in6_if_up(IF_GET_IFNET());
 
-#endif	/* of #if defined(SUPPORT_INET6) && !defined(SUPPORT_TCP) */
+#endif	/* of #if defined(_IP6_CFG) && !defined(SUPPORT_TCP) */
 
 	while (true) {
@@ -248,11 +180,28 @@
 		syscall(wai_sem(SEM_UDP_POST_OUTPUT));
 
-		for (ix = tmax_udp_ccepid; ix -- > 0; ) {
-
-			if (udp_cep[ix].flags & UDP_CEP_FLG_POST_OUTPUT) {
-				udp_cep[ix].flags &= ~UDP_CEP_FLG_POST_OUTPUT;
-				udp_output(&udp_cep[ix]);
+#if defined(_IP6_CFG) && TNUM_UDP6_CEPID > 0
+
+		for (ix = tmax_udp6_cepid; ix -- > 0; ) {
+
+			if (udp6_cep[ix].flags & UDP_CEP_FLG_POST_OUTPUT) {
+				udp6_cep[ix].flags &= ~UDP_CEP_FLG_POST_OUTPUT;
+				udp6_output(&udp6_cep[ix]);
 				}
 			}
+
+#endif	/* of #if defined(_IP6_CFG) && TNUM_UDP6_CEPID > 0 */
+
+#if defined(_IP4_CFG) && TNUM_UDP4_CEPID > 0
+
+		for (ix = tmax_udp4_cepid; ix -- > 0; ) {
+
+			if (udp4_cep[ix].flags & UDP_CEP_FLG_POST_OUTPUT) {
+				udp4_cep[ix].flags &= ~UDP_CEP_FLG_POST_OUTPUT;
+				udp4_output(&udp4_cep[ix]);
+				}
+			}
+
+#endif	/* of #if defined(_IP4_CFG) && TNUM_UDP4_CEPID > 0 */
+
 		}
 	}
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/udp_subr.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/udp_subr.c	(revision 321)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/udp_subr.c	(revision 331)
@@ -2,5 +2,5 @@
  *  TINET (UDP/IP Protocol Stack)
  * 
- *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
+ *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
  *                   Tomakomai National College of Technology, JAPAN
  *
@@ -71,5 +71,7 @@
 #include <kernel.h>
 #include <sil.h>
+#include <t_syslog.h>
 #include "kernel_cfg.h"
+#include "tinet_cfg.h"
 
 #endif	/* of #ifdef TARGET_KERNEL_ASP */
@@ -80,4 +82,5 @@
 #include <t_services.h>
 #include "kernel_id.h"
+#include "tinet_id.h"
 
 #endif	/* of #ifdef TARGET_KERNEL_JSP */
@@ -91,4 +94,5 @@
 #include <net/ethernet.h>
 #include <net/net.h>
+#include <net/net_endian.h>
 #include <net/net_buf.h>
 #include <net/net_count.h>
@@ -96,5 +100,4 @@
 
 #include <netinet/in.h>
-#include <netinet6/in6.h>
 #include <netinet/in_var.h>
 #include <netinet/in_itron.h>
@@ -102,11 +105,9 @@
 #include <netinet/ip_var.h>
 #include <netinet/ip_icmp.h>
-#include <netinet6/in6_var.h>
-#include <netinet/ip6.h>
-#include <netinet6/ip6_var.h>
-#include <netinet6/nd6.h>
-#include <netinet/icmp6.h>
 #include <netinet/udp.h>
 #include <netinet/udp_var.h>
+#include <netinet/ip_igmp.h>
+
+#include <net/if_var.h>
 
 #ifdef SUPPORT_UDP
@@ -116,61 +117,80 @@
  */
 
+#if (defined(_IP6_CFG) && TNUM_UDP6_CEPID > 0) || (defined(_IP4_CFG) && TNUM_UDP4_CEPID > 0)
+
 static uint16_t udp_port_auto = UDP_PORT_FIRST_AUTO;	/* 自動割り当て番号	*/
 
+#endif	/* of #if (defined(_IP6_CFG) && TNUM_UDP6_CEPID > 0) || (defined(_IP4_CFG) && TNUM_UDP4_CEPID > 0) */
+
 /*
- *  udp_alloc_auto_port -- 自動割り当てポート番号を設定する。
+ *  IPv6 と IPv4 で引数が異なる関数のコンパイル
  */
 
-ER
-udp_alloc_auto_port (T_UDP_CEP *cep)
-{
-	int_t	ix;
-	uint16_t	portno, portno_start;
+#if defined(_IP6_CFG) && TNUM_UDP6_CEPID > 0
 
-	portno_start = udp_port_auto;
-	do {
-		portno = udp_port_auto ++;
-		if (udp_port_auto > UDP_PORT_LAST_AUTO)
-			udp_port_auto = UDP_PORT_FIRST_AUTO;
+#if defined(_IP4_CFG) && defined(API_CFG_IP4MAPPED_ADDR)
 
-		syscall(wai_sem(SEM_UDP_CEP));
-		for (ix = tmax_udp_ccepid; ix -- > 0; ) {
-			if (VALID_UDP_CEP(&udp_cep[ix]) && udp_cep[ix].myaddr.portno == portno) {
-				portno = UDP_PORTANY;
-				break;
-				}
-			}
+#define UDP_IS_DSTADDR_ACCEPT	udpn_is_dstaddr_accept
 
-		if (portno != UDP_PORTANY) {
-			cep->myaddr.portno = portno;
-			syscall(sig_sem(SEM_UDP_CEP));
-			return E_OK;
-			}
-		syscall(sig_sem(SEM_UDP_CEP));
+#else	/* of #if defined(_IP4_CFG) */
 
-		} while (portno_start != udp_port_auto);
+#define UDP_IS_DSTADDR_ACCEPT	udp6_is_dstaddr_accept
 
-	return E_NOID;
-	}
+#endif	/* of #if defined(_IP4_CFG) */
 
-/*
- *  udp_alloc_port -- 指定されたポート番号を設定する。
- */
+#define UDP_SEND_DATA		udp6_send_data
+#define UDP_CAN_SND		udp6_can_snd
+#define UDP_CAN_RCV		udp6_can_rcv
+#define UDP_ALLOC_AUTO_PORT	udp6_alloc_auto_port
+#define UDP_ALLOC_PORT		udp6_alloc_port
+#define UDP_FIND_CEP		udp6_find_cep
+#define UDP_NOTIFY		udp6_notify
+#define TMAX_UDP_CEPID		tmax_udp6_cepid
+#define UDP_CEP			udp6_cep
+#define T_UDP_CEP		T_UDP6_CEP
+#define T_IPEP			T_IPV6EP
+#define API_PROTO		API_PROTO_IPV6
 
-ER
-udp_alloc_port (T_UDP_CEP *cep, uint16_t portno)
-{
-	int_t	ix;
+#include <netinet6/udp6_subr.c>
+#include <netinet/udpn_subr.c>
 
-	syscall(wai_sem(SEM_UDP_CEP));
-	for (ix = tmax_udp_ccepid; ix -- > 0; )
-		if (VALID_UDP_CEP(&udp_cep[ix]) && udp_cep[ix].myaddr.portno == portno) {
-			syscall(sig_sem(SEM_UDP_CEP));
-			return E_PAR;
-			}
-	cep->myaddr.portno = portno;
-	syscall(sig_sem(SEM_UDP_CEP));
-	return E_OK;
-	}
+#undef	UDP_SEND_DATA
+#undef	UDP_CAN_SND
+#undef	UDP_CAN_RCV
+#undef	UDP_ALLOC_AUTO_PORT
+#undef	UDP_ALLOC_PORT
+#undef	UDP_FIND_CEP
+#undef	UDP_NOTIFY
+#undef	UDP_IS_DSTADDR_ACCEPT
+#undef	TMAX_UDP_CEPID
+#undef	UDP_CEP
+#undef	T_UDP_CEP
+#undef  T_IPEP
+#undef  API_PROTO
+
+#endif	/* of #if defined(_IP6_CFG) && TNUM_UDP6_CEPID > 0 */
+
+#if defined(_IP4_CFG) && ( (TNUM_UDP4_CEPID > 0) || \
+                          ((TNUM_UDP6_CEPID > 0) && defined(API_CFG_IP4MAPPED_ADDR)))
+
+#define UDP_IS_DSTADDR_ACCEPT	udp4_is_dstaddr_accept
+
+#define UDP_SEND_DATA		udp4_send_data
+#define UDP_CAN_SND		udp4_can_snd
+#define UDP_CAN_RCV		udp4_can_rcv
+#define UDP_ALLOC_AUTO_PORT	udp4_alloc_auto_port
+#define UDP_ALLOC_PORT		udp4_alloc_port
+#define UDP_FIND_CEP		udp4_find_cep
+#define UDP_NOTIFY		udp4_notify
+#define TMAX_UDP_CEPID		tmax_udp4_cepid
+#define T_UDP_CEP		T_UDP4_CEP
+#define UDP_CEP			udp4_cep
+#define T_IPEP			T_IPV4EP
+#define API_PROTO		API_PROTO_IPV4
+
+#include <netinet/udp4_subr.c>
+#include <netinet/udpn_subr.c>
+
+#endif	/* of #if defined(_IP4_CFG) && TNUM_UDP4_CEPID > 0 */
 
 #endif	/* of #ifdef SUPPORT_UDP */
